#include <sragent.h>
#include <srlogger.h>
#include "integrate.h"
#include <cstdlib>
#include <string.h>
#include <srreporter.h>
#include <stdio.h>
#include <iostream>
#include <stdio.h>
#include "clistatus.h"
#include <utility>
#include <string>
#include <algorithm>
#include <sstream>

using namespace std;

void trim(char * s) {
    char * p = s;
    int l = strlen(p);

    while(isspace(p[l - 1])) p[--l] = 0;
    while(* p && isspace(* p)) ++p, --l;

    memmove(s, p, l + 1);
}

void find_and_replace(string& source, string const& find, string const& replace)
{
    for(string::size_type i = 0; (i = source.find(find, i)) != string::npos;)
    {
        source.replace(i, find.length(), replace);
        i += replace.length();
    }
}



string new_getStatus(const char *s) 
{
	return getStatus(s, "cli status -s");

}

string cli_get(const char *str) 
{
	char execute[1024];
	string s(str);
	transform(s.begin(), s.end(), s.begin(), ::tolower);
	find_and_replace(s, "_", ".");
	snprintf(execute, 1023, "cli get %s -s", s.c_str());

	return getStatus(str, execute);

}

string getStatus(const char *s, const char *command)
{
        FILE *fp = popen(command, "r");
        char *var = NULL, *value = NULL, *l;
        int str_len = 0;
	char line[1024];

        if (!fp) return NULL;
	while (!feof(fp)) {
		if (!fgets(line, sizeof(line)-1, fp)) break;
		l = line;
		var = strtok(l, "=");
                value = strtok(NULL, "=");
                trim(value);
                if (strcmp(var, s) == 0) {
                        str_len = strlen(value);
                        value[str_len - 1] = '\0';
                        printf("%s IS %s\n", s,(value + 1));
                        break;
                }

}

        pclose(fp);
        return (value + 1);
}

int getDigitalIO(string s)
{
	int i;

	if(s.compare("off") == 0){
		i = 0;
	}
	if(s.compare("on") == 0){
		i = 1;
	}
	return i;
}

string getMonth(int month)
{
	switch(month)
	{
		case 1: return "Jan"; break;
		case 2: return "Feb"; break;
		case 3: return "Mar"; break;
		case 4: return "Apr"; break;
		case 5: return "May"; break;
		case 6: return "Jun"; break;
		case 7: return "Jul"; break;
		case 8: return "Aug"; break;
		case 9: return "Sep"; break;
		case 10: return "Oct"; break;
		case 11: return "Nov"; break;
		case 12: return "Dec"; break;
		default: return "";
		
	}	
}
int getLength(int m){
		
	int length = 1;
	
	int k = m;
	while ( k /= 10 )
        	length++;

	return length;
}
string getString(int a){

	stringstream Str;
        Str << a;
        string ZahlAlsString(Str.str());
	return ZahlAlsString;

}
string getZero(int b){
	if (b<=0 || b<10){
		switch(b){
			case 0:return "00"; break;
			case 1:return "01"; break;
			case 2:return "02"; break;
			case 3:return "03"; break;
			case 4:return "04"; break;
			case 5:return "05"; break;
			case 6:return "06"; break;
			case 7:return "07"; break;
			case 8:return "08"; break;
			case 9:return "09"; break;
			default: return "";
		}
	}else{
		return getString(b);	
	}
}
void getFileOverSCP(const char *scpCommand)
{
	FILE* file = popen(scpCommand, "r");

	if (file == NULL)
		cout << "error" << endl;
}
